function love.load()
  require("anal")
  spritesheet = love.graphics.newImage("spritesheet.png")
  spritesheet:setFilter("nearest", "nearest")
  animation = newAnimation(spritesheet, 16, 16, 0.3, 4)
  animationState = "thread" --this flag note down what the tank is doing right now
  shot = false              --this flag helps the tank to remember whether it has shot or not
end

function love.update(dt)
  animation:update(dt)
  local cf = animation:getCurrentFrame()
  if animationState == "thread" then    --when the tank is threading, loop only the first two frames, so
    if cf == 3 then                     --if the animation reaches frame no.3,
      animation:seek(1)                 --go to frame no.1 directly
    end
  elseif animationState == "shoot" then --when the tank is shooting, let the loop goes through the frames, but
    if cf == 4 then                     --when it reaches the last frame, we need to note down that
      shot = true                       --the bullet has been shot, so that
    elseif cf == 1 and shot then        --when the animation reaches frame no.1 and the bullet 
      animationState = "thread"         
      shot = false                      
    end
  end
end

function love.draw()
  animation:draw(16, 16, 0, 4.5)
  if animationState == "shoot" and animation:getCurrentFrame() == 4 then
    love.graphics.print("BOOM!", 200, 64)
  end
  love.graphics.print(animation:getCurrentFrame(), 8, 64)
  love.graphics.print(animationState, 16, 80)
  love.graphics.print("[spc] shoot!", 16, 96)
  love.graphics.print("[esc] quit application", 16, 108)
end

function love.keypressed(key)
  if key == " " then
    animationState = "shoot"
  elseif key == "escape" or key == "q" then
    love.event.push("q")
  end
end
